// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __EXCITWIN_H
#define	__EXCITWIN_H


#include <clxclient.h>
#include "vocoder.h"
#include "guiclass.h"


class Excitwin : public X_window, public X_callback
{
public:

    enum { XSIZE = 209,	YSIZE = 57 };

    Excitwin (X_window *parent, int xp, int yp, Vocoder *vocoder, int ident);
    ~Excitwin (void);

    
private:

    enum { R_GAIN, R_EQ1G, R_EQ2G, B_INTL };
    
    void handle_event (XEvent *);
    void handle_callb (int type, X_window *W, XEvent *E);
    void expose (XExposeEvent *E);
    void redraw (void);

    Vocoder        *_vocoder;
    char            _ident;
    PushButton     *_bintl;
    RotaryGeom      _gain_geom;
    RotaryGeom      _eq1g_geom;
    RotaryGeom      _eq2g_geom;
    RotaryCtl      *_rgain;
    RotaryCtl      *_req1g;
    RotaryCtl      *_req2g;
};


#endif
