// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __FILTWIN_H
#define	__FILTWIN_H


#include <clxclient.h>
#include "mcled.h"
#include "vocoder.h"
#include "guiclass.h"


class Filtwin : public X_window, public X_callback
{
public:

    enum
    {
	NBAND = Vocoder::NBAND,
	XSTEP = 21,
	XSIZE = 535,
	YSTEP = 29,
	YSIZE = 95
    };

    Filtwin (X_window *parent, int xp, int yp, Vocoder *vocoder);
    ~Filtwin (void);

    void update (void); 
    
    
private:

    void handle_event (XEvent *);
    void handle_callb (int type, X_window *W, XEvent *E);
    void expose (XExposeEvent *E);
    void redraw (void);

    Vocoder        *_vocoder;
    RotaryGeom      _gain_geom;
    RotaryCtl      *_rinput;
    RotaryCtl      *_rbgain [NBAND];
    Mcled          *_levled [NBAND];
};


#endif
