// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __INPUTWIN_H
#define	__INPUTWIN_H


#include <clxclient.h>
#include "vocoder.h"
#include "guiclass.h"
#include "mcled.h"


class Inputwin : public X_window, public X_callback
{
public:

    enum
    {
	XSIZE = 194,
	YSIZE = 75
    };

    Inputwin (X_window *parent, int xp, int yp, Vocoder *vocoder);
    ~Inputwin (void);

    void update (void);
    
private:

    enum { R_GAIN, R_UVRT, B_HOLD };
    
    void handle_event (XEvent *);
    void handle_callb (int type, X_window *W, XEvent *E);
    void expose (XExposeEvent *E);
    void redraw (void);

    Vocoder        *_vocoder;
    RotaryGeom      _gain_geom;
    RotaryGeom      _uvrt_geom;
    RotaryCtl      *_rgain;
    RotaryCtl      *_ruvrt;
    PushButton     *_bhold;
    Mcled          *_Uled;
    Mcled          *_Vled;
};


#endif
