// -----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// -----------------------------------------------------------------------------


#include <stdlib.h>
#include <math.h>
#include "styles.h"
#include "mcled.h"


Mcled::Mcled (X_window *par, int xp, int yp, XImage *imag) :
    _par (par),
    _xp (xp),
    _yp (yp),
    _imag (imag),
    _k (0)
{
    render ();
}


Mcled::~Mcled (void)
{
}


void Mcled::update (int k)
{
    if (k < 0)  k = 0;
    if (k > 14) k = 14;
    if (k == _k) return;
    _k = k;
    render ();
}


void Mcled::render (void)
{
    XPutImage (_par->dpy (), _par->win (), _par->dgc (), _imag,
	       _k * XSIZE, 0, _xp, _yp, XSIZE, YSIZE); 
}


