// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __OSCILWIN_H
#define	__OSCILWIN_H


#include <clxclient.h>
#include "vocoder.h"
#include "guiclass.h"


class Oscilwin : public X_window, public X_callback
{
public:

    enum
    {
	XSIZE = 259,
	YSIZE = 57
    };

    Oscilwin (X_window *parent, int xp, int yp, Vocoder *vocoder);
    ~Oscilwin (void);

    
private:

    enum { R_FREQ, R_TUNE, R_FMOD, R_LFOF, B_MIDI };

    void handle_event (XEvent *);
    void handle_callb (int type, X_window *W, XEvent *E);
    void expose (XExposeEvent *E);
    void redraw (void);

    Vocoder        *_vocoder;
    PushButton     *_bmidi;
    RotaryGeom      _freq_geom;
    RotaryGeom      _tune_geom;
    RotaryGeom      _fmod_geom;
    RotaryGeom      _lfof_geom;
    RotaryCtl      *_rfreq;
    RotaryCtl      *_rtune;
    RotaryCtl      *_rfmod;
    RotaryCtl      *_rlfof;
};


#endif
