// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __SAWOSC_H
#define __SAWOSC_H


class Sawosc
{
public:

    Sawosc (void);
    ~Sawosc (void);

    void reset (void);
    void set_freq (float f, bool step);
    void process (int nfram, float *out);


private:

    enum { LSINC = 12, KUPS = 64 };
    
    int     _k;
    float   _f1, _f, _p, _u, _v;
    float  *_sincp;
};


#endif
