// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __SVFILT_H
#define __SVFILT_H


// 'State Variable' second order section.


class SVfilt
{
public:

    SVfilt (void);
    ~SVfilt (void);

    void  reset (void) { _z1 = _z2 = 0; }
    void  init (float f, float q, float g = 1.0f);
    void  proc_lowpass (int n, float *inp, float *out);
    void  proc_bandpass (int n, float *inp, float *out);
    void  proc_highpass (int n, float *inp, float *out);
    
private:

    float _g;        // Passband gain.
    float _c1, _c2;  // Integrator gains.
    float _z1, _z2;  // Filter state.
};


#endif
